"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeI18n = void 0;
const devopsCore_1 = require("@thatdevops/core/devopsCore");
const makeRunable_1 = __importDefault(require("@thatdevops/core/utils/makeRunable"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const devopsCode_1 = require("../devopsCode");
exports.makeI18n = (0, makeRunable_1.default)(() => __awaiter(void 0, void 0, void 0, function* () {
    const { rootPath } = (0, devopsCore_1.getDevOpsCore)();
    const { i18n } = (0, devopsCode_1.getDevOpsCodeC)();
    i18n.forEach(({ baseDir, mergeDirs, outDir }) => {
        const baseFiles = fs_1.default.readdirSync(path_1.default.join(rootPath, baseDir));
        baseFiles.forEach(baseFile => {
            if (!baseFile.endsWith('.json'))
                return;
            const baseCnt = JSON.parse(fs_1.default.readFileSync(path_1.default.join(rootPath, baseDir, baseFile), 'utf8').toString());
            mergeDirs.forEach(mergeDir => {
                const mergeFiles = fs_1.default.readdirSync(path_1.default.join(rootPath, mergeDir));
                mergeFiles.forEach(mergeFile => {
                    const mergeCnt = JSON.parse(fs_1.default.readFileSync(path_1.default.join(rootPath, mergeDir, mergeFile), 'utf8').toString());
                    Object.keys(mergeCnt).forEach(key => {
                        if (!baseCnt[key])
                            baseCnt[key] = mergeCnt[key];
                    });
                });
            });
            fs_1.default.writeFileSync(path_1.default.join(rootPath, outDir, baseFile), JSON.stringify(baseCnt, null, 4));
        });
    });
}));
exports.default = exports.makeI18n;
//# sourceMappingURL=makeI18n.js.map